.globl	mystrcpy

/*
 * char *mystrcpy(char *dst, const char *src)
 *
 * Vor dem pushl %ebp:
 * 	(%esp): Ruecksprungadresse
 * 	4(%esp): dst
 * 	8(%esp): src
 */
mystrcpy:
	/* Framepointer aufsetzen */
	pushl	%ebp
	movl	%esp, %ebp

	/*
	 * dst liegt jetzt bei 8(%ebp)
	 * src liegt jetzt bei 12(%ebp)
	 */
	
	/* Verwendete Register sichern */
	pushl	%edi
	pushl	%esi
	
	movl	8(%ebp), %edi		/* %edi = dst */
	movl	12(%ebp), %esi		/* %esi = src */

	/*
	 * cld stellt sicher, dass %esi und %edi bei Befehlen wie
	 * lodsb, stosb, movsb usw. inkrementiert werden.
	 *
	 * std sorgt dafuer, dass %esi und %edi dekrementiert werden.
	 */
	cld
	
	/*
	 * Wert von Adresse (%esi) in %al laden, %esi wird um eins
	 * inkrementiert
	 */
1:	lodsb		

	cmpb	$0, %al
	jz	1f	/* '\0' character erreicht? Wenn ja, zurueckkehren */
	
	/*
	 * Wert von %al an Adresse (%edi) schreiben, %edi wird um eins
	 * inkrementiert.
	 */
	stosb
	jmp	1b		/* Sprung zurueck zu lodsb */
	
	/* Register wiederherstellen */
1:	popl	%esi
	popl	%edi

	movl	8(%ebp), %eax		/* Rueckgabewert: %eax = dst */

	popl	%ebp
	ret
